----------- Missing Purchase Return
insert into PurchaseReturnBillMaster (Account_Id,PurchaseReturn_RowId,Bill_No,Bill_Date,Net_Amount,Paid_Amount,Settlement_Flg,Settle_Amt,Settle_RowId,User_Id,Year_Id,Comp_Id,Remarks,SettleTrans_ID,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,DueDay)
select Account_Id,rowid,bill_no,Bill_Date, ROUND(NetAmount,0), 
	case when CashOrCredit!='credit' then	ROUND(NetAmount,0) else null end,case when CashOrCredit!='credit' then	1 else 0 end,0,null,User_Id,Year_Id,Comp_Id,remarks,0,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,Due_Day
from PurchaseReturnMst p where rowid not in(select PurchaseReturn_RowId from PurchaseReturnBillMaster where year_id=p.year_id)
GO
update PurchaseReturnBillMaster set Settlement_Flg=1 where isnull(net_amount,0)<=isnull(Paid_Amount,0)+isnull(Settle_Amt,0)
GO
 update PurchaseReturnBillMaster set paid_amount=t.paidanount,Settle_Amt=t.Settleanount from
(select isnull(sum(isnull(amount,0)),0)paidanount,isnull(sum(isnull(settle_amt,0)),0)Settleanount,bill_rowid  from SattleBillId where Flg='PR' group by Bill_RowId) t
 where paid_amount<0 and t.Bill_RowId=PurchaseReturnBillMaster.RowId
GO
 Update PurchaseReturnBillMaster set paid_amount=0
 where paid_amount<0 
 GO
update PurchaseReturnBillMaster set Settlement_Flg=0 where Net_Amount-Paid_Amount-Settle_Amt>0 and (remarks != 'Force Bill Settlement' or remarks is null)
GO

update PurchaseReturnBillMaster set PurchaseReturnBillMaster.year_id = t.year_id
from(select year_id,RowId from PurchaseReturnMst a) as t  where t.RowId=PurchaseReturnBillMaster.PurchaseReturn_RowId
GO
----------- Missing Sales Return
insert into salesReturnBillMaster (Account_Id,salesReturn_RowId,Bill_No,Bill_Date,Net_Amount,Paid_Amount,Settlement_Flg,Settle_Amt,Settle_RowId,User_Id,Year_Id,Comp_Id,Remarks,SettleTrans_ID,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,DueDay)
select Account_Id,rowid,bill_no,Bill_Date, ROUND(NetAmount,0), 
	case when CashOrCredit!='credit' then	ROUND(NetAmount,0) else null end,case when CashOrCredit!='credit' then	1 else 0 end,0,null,User_Id,Year_Id,Comp_Id,remarks,0,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,Due_Day
from salesReturnMst p where rowid not in(select salesReturn_RowId from salesReturnBillMaster where year_id=p.year_id)
GO
update salesReturnBillMaster set Settlement_Flg=1 where isnull(net_amount,0)<=isnull(Paid_Amount,0)+isnull(Settle_Amt,0)
GO
 update salesReturnBillMaster set paid_amount=t.paidanount,Settle_Amt=t.Settleanount from
(select isnull(sum(isnull(amount,0)),0)paidanount,isnull(sum(isnull(settle_amt,0)),0)Settleanount,bill_rowid  from SattleBillId where Flg='SR' group by Bill_RowId) t
 where paid_amount<0 and t.Bill_RowId=salesReturnBillMaster.RowId
GO
 Update salesReturnBillMaster set paid_amount=0
 where paid_amount<0 
 GO
 update salesReturnBillMaster set Settlement_Flg=0 where Net_Amount-Paid_Amount-Settle_Amt>0 and (remarks != 'Force Bill Settlement' or remarks is null)
GO
update salesReturnBillMaster set salesReturnBillMaster.year_id = t.year_id
from(select year_id,RowId from salesReturnMst a) as t  where t.RowId=salesReturnBillMaster.salesReturn_RowId
GO

--Missing in DebitNoteBillMaster 
insert into DebitNoteBillMaster 
(Account_Id,Debit_Rowid,DebitNo,DebitDate,Net_Amount,Paid_Amount,Settlement_Flg,Settle_Amt,User_Id,Year_Id,Comp_Id,Remarks,SettleTrans_ID,NoteType,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,DueDay)
select Account_Id,rowid,DebitNo,DebitDate, ROUND(Net_Amount,0), (select isnull(sum(isnull(netAmount,0)),0) from debitnotetrans where Master_Id=p.RowId and isnull(Purchase_ID,0)>0 and Note_Type='PV'),
0,0,User_Id,Year_Id,Comp_Id,remarks,0,NoteType,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,null
from DebitNoteMaster p where rowid not in(select Debit_Rowid from DebitNoteBillMaster where year_id=p.year_id)
GO
--Missing in CreditNoteBillMaster
insert into CreditNoteBillMaster 
(Account_Id,Credit_Rowid,CreditNo,CreditDate,Net_Amount,Paid_Amount,Settlement_Flg,Settle_Amt,User_Id,Year_Id,Comp_Id,Remarks,SettleTrans_ID,NoteType,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,DueDay)
select Account_Id,rowid,CreditNo,CreditDate, ROUND(Net_Amount,0), (select isnull(sum(isnull(netAmount,0)),0) from Creditnotetrans where Master_Id=p.RowId and isnull(Sales_ID,0)>0 and Note_Type='SV'),
0,0,User_Id,Year_Id,Comp_Id,remarks,0,NoteType,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,null
from CreditNoteMaster p where rowid not in(select Credit_Rowid from CreditNoteBillMaster where year_id=p.year_id)
GO
update DebitNoteBillMaster set Settlement_Flg=1 where isnull(net_amount,0)<=isnull(Paid_Amount,0)+isnull(Settle_Amt,0)
GO
update CreditNoteBillMaster set Settlement_Flg=1 where isnull(net_amount,0)<=isnull(Paid_Amount,0)+isnull(Settle_Amt,0)
GO
 update PurchaseBillMaster set paid_amount=t.paidanount,Settle_Amt=t.Settleanount from
(select isnull(sum(isnull(amount,0)),0)paidanount,isnull(sum(isnull(settle_amt,0)),0)Settleanount,bill_rowid  from SattleBillId where Flg='P' group by Bill_RowId) t
 where paid_amount<0 and t.Bill_RowId=PurchaseBillMaster.RowId
GO
 Update PurchaseBillMaster set paid_amount=0
 where paid_amount<0 
 GO
update SalesBillMaster  set paid_amount=t.paidanount,Settle_Amt=t.Settleanount from
(select isnull(sum(isnull(amount,0)),0)paidanount,isnull(sum(isnull(settle_amt,0)),0)Settleanount,bill_rowid  from SattleBillId where Flg='s' group by Bill_RowId) t
 where paid_amount<0 and t.Bill_RowId=SalesBillMaster.RowId
GO
 Update SalesBillMaster  set paid_amount=0
 where paid_amount<0 
 GO
update purchasebillmaster set Settlement_Flg=0 where Net_Amount-Paid_Amount-Settle_Amt>0 and (remarks != 'Force Bill Settlement' or remarks is null)
GO
update Salesbillmaster set Settlement_Flg=0 where Net_Amount-Paid_Amount-Settle_Amt>0 and (remarks != 'Force Bill Settlement' or remarks is null)
GO


update PurchaseBillMaster  set PurchaseBillMaster.year_id = t.year_id
from(select year_id,RowId from PurchaseMaster a) as t  where t.RowId=PurchaseBillMaster.Purchase_RowId
GO
update SalesBillMaster  set SalesBillMaster.year_id = t.year_id
from(select year_id,RowId from salesmaster a) as t  where t.RowId=SalesBillMaster.Sales_RowId
GO
update serialkeymaster set IsPurchase=1 where rowid in(select SubTrans_ID from SerialKeyMaster where isnull(SubTrans_ID,0)>0 )
GO
update purchasebillmaster set Settlement_Flg=1 where Net_Amount<=Settle_Amt+Paid_Amount
GO
update salesbillmaster set Settlement_Flg=1 where Net_Amount<=Settle_Amt+Paid_Amount
GO

--missing in purchasebillmaster
insert into PurchaseBillMaster (Account_Id,Purchase_RowId,Bill_No,Bill_Date,Net_Amount,Paid_Amount,Settlement_Flg,Settle_Amt,Settle_RowId,User_Id,Year_Id,Comp_Id,Remarks,SettleTrans_ID,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,DueDay)
select Account_Id,rowid,bill_no,Bill_Date, ROUND(NetAmount,0), 
	case when CashOrCredit!='credit' then	ROUND(NetAmount,0) else null end,case when CashOrCredit!='credit' then	1 else 0 end,0,null,User_Id,Year_Id,Comp_Id,remarks,0,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,Due_Day
from PurchaseMaster p where rowid not in(select purchase_rowid from PurchaseBillMaster where year_id=p.year_id)

GO
--missing in salesbillmaster

insert into SalesBillMaster (Account_Id,Sales_RowId,Bill_No,Bill_Date,Net_Amount,Paid_Amount,Settlement_Flg,Settle_Amt,Settle_RowId,User_Id,Year_Id,Comp_Id,Remarks,SettleTrans_ID,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,DueDay)
select Account_Id,rowid,bill_no,Bill_Date, ROUND(NetAmount,0), 
	case when CashOrCredit!='credit' then	ROUND(NetAmount,0) else null end,case when CashOrCredit!='credit' then	1 else 0 end,0,null,User_Id,Year_Id,Comp_Id,remarks,0,InsertTime,UpdateTime,InsertComputerName,UpdateComputerName,Due_Day
from SalesMaster p where rowid not in(select sales_rowid from SalesBillMaster where year_id=p.year_id)

GO

--Insert Purchase missing entry in Account Transaction 

insert into AccountTransaction (Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select Bill_Date,Account_Transaction_Id,1,'PV',PurchaseAccount_ID,Account_Id, ROUND(NetAmount,0), 
		ROUND(NetAmount,0),User_Id,Year_Id,Comp_Id,substring(VatType,1,1)+' '+Bill_No,InsertTime,InsertComputerName
from PurchaseMaster 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='PV')
GO

--Insert Sales missing entry in Account Transaction

insert into AccountTransaction 
(Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select Bill_Date,Account_Transaction_Id,1,'SV',Account_Id,SalesAccount_Id, ROUND(NetAmount,0), 
		ROUND(NetAmount,0),User_Id,Year_Id,Comp_Id,substring(VatType,1,1)+' '+convert(varchar,Bill_No),InsertTime,InsertComputerName 
from SalesMaster 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='SV')
GO

--Insert Purchase Return missing entry in Account Transaction

insert into AccountTransaction (Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select Bill_Date,Account_Transaction_Id,1,'PR',Account_Id,SalesAccount_Id, ROUND(NetAmount,0), 
		ROUND(NetAmount,0),User_Id,Year_Id,Comp_Id,substring(VatType,1,1)+' '+Bill_No,InsertTime,InsertComputerName
from PurchaseReturnMst 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='PR')
GO


--Insert Sales Return missing entry in Account Transaction

insert into AccountTransaction 
(Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select Bill_Date,Account_Transaction_Id,1,'SR',PurchaseAccount_ID,Account_Id, ROUND(NetAmount,0), 
ROUND(NetAmount,0),User_Id,Year_Id,Comp_Id,substring(VatType,1,1)+' '+Bill_No,InsertTime,InsertComputerName 
from SalesReturnMst 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='SR')
GO

--Delete AccountTransaction  Entry which is not in purchase 
delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='PV' and 
Transaction_Id not in (select Account_Transaction_Id from PurchaseMaster))
GO

--Delete AccountTransaction  Entry which is not in Sales

delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='SV' and 
Transaction_Id not in (select Account_Transaction_Id from SalesMaster))
GO

--Delete AccountTransaction  Entry which is not in purchase Return

delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='PR' and 
Transaction_Id not in (select Account_Transaction_Id from PurchaseReturnMst))
GO

--Delete AccountTransaction  Entry which is not in Sales Return

delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='SR' and 
Transaction_Id not in (select Account_Transaction_Id from SalesReturnMst))
GO
--Insert CreditNoteMaster missing entry in Account Transaction 
insert into AccountTransaction (Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select CreditDate,Account_Transaction_Id,1,'CN',CreditAccount,Account_Id, Total_Amount, 
		Total_Amount,User_Id,Year_Id,Comp_Id,CreditNo,InsertTime,InsertComputerName
from CreditNoteMaster 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='CN') and AccYesNo='Yes'
GO

--Delete AccountTransaction  Entry which is not in CreditNoteMaster
delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='CN' and 
Transaction_Id not in (select Account_Transaction_Id from CreditNoteMaster))
GO

--Insert DebitNoteMaster missing entry in Account Transaction 
insert into AccountTransaction (Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select DebitDate,Account_Transaction_Id,1,'DN',Account_Id,DebitAccount, Total_Amount, 
		Total_Amount,User_Id,Year_Id,Comp_Id,DebitNo,InsertTime,InsertComputerName
from DebitNoteMaster 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='DN') and AccYesNo='Yes'
GO

--Delete AccountTransaction  Entry which is not in DebitNoteMaster
delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='DN' and 
Transaction_Id not in (select Account_Transaction_Id from DebitNoteMaster))
GO

--Insert InwardsMaster missing entry in Account Transaction 
insert into AccountTransaction (Transaction_Date,Transaction_Id,SubTransaction_Id,Transaction_Type,Account_Id,Trans_Account_ID,Dr_Amt,Cr_Amt,User_Id,Year_Id,Comp_Id,Bill_No,InsertTime,InsertComputerName)
select Challan_Date,Account_Transaction_Id,1,'IW',SalesRowId,Account_Id, ROUND(Total_Amount,0), 
		ROUND(Total_Amount,0),User_Id,Year_Id,Comp_Id,Challan_No,InsertTime,InsertComputerName
from InwardsMaster 
where Account_Transaction_Id not in (select Transaction_Id from AccountTransaction where Transaction_Type='IW') and Account_Transaction_Id<>0 and Account_Transaction_Id<> null
GO

--Delete AccountTransaction  Entry which is not in InwardsMaster
delete from AccountTransaction where rowid in(select RowId from AccountTransaction where Transaction_Type='IW' and 
Transaction_Id not in (select Account_Transaction_Id from InwardsMaster))
GO
--Create index
CREATE INDEX idx_name_hsn_tag
ON ItemMaster (rowid,item_name,hsnno,item_tag)

Go 
CREATE INDEX idx_serialkey
ON SerialKeyMaster (rowid,SerialKey)

Go 
CREATE INDEX idx_ExpireDate_manufacDate
ON SerialKeyMaster (rowid,ExpireDate,manufacDate)

Go 
CREATE INDEX idx_billno_billdate
on SalesMaster (rowid,bill_no,bill_date)

Go 
CREATE INDEX idx_itemid_pid_qty
ON PurchaseMasterTrans (item_id,Purchase_Id,Qty)

Go 
CREATE INDEX idx_itemid_sid_qty
ON SalesMasterTrans (item_id,Sales_Id,Qty) 

Go 
CREATE INDEX idx_itemid_pid_qty
ON SalesReturnMstTrans (item_id,Purchase_Id,Qty)

Go 
CREATE INDEX idx_itemid_sid_qty
ON PurchaseReturnMstTrans (item_id,Sales_Id,Qty)

Go 
CREATE INDEX idx_itemid_sid_qty
ON InwardsTrans (item_id,Sales_Id,Qty)

Go 
CREATE INDEX idx_itemid_sid_qty
ON OutwardsTrans (item_id,Sales_Id,Qty)

Go 
CREATE INDEX idx_itemid_totalqty
ON ProdCon (item_id,TotalQty)

Go 
CREATE INDEX idx_itemid_mid_trnqty
ON ProdMsttrnwithpacking (item_id,Master_ID,TrnQty)

Go 
CREATE INDEX idx_itemid_totalqty
ON ProdMstwithpacking (item_id,TotalQty)

Go 
CREATE INDEX idx_itemid_mid_prodqty
ON ProdMstTrnPackingOnly (item_id,Master_ID,ProdQty) 